function FRexamples

ms = 1e3;
f = 110; %Hz
T = 1/f;
T = T;
t = 0:0.0001:2*T;
A = pi/4;%m

n=1000;
velt = length(t);
% four.koef. pro obdelnik
FkoefsOBD = [1,0,1/3,0,1/5,0,1/7,0,1/9,0,1/11];
FlengthOBD = length(FkoefsOBD);

h=figure;
% ---------------------------------
for i=1:length(t)
    [st] = OBD(t(i),A,n,f);  
    signalOBD(i) = st;  
end
signal = 0;

for i=1:length(t)
    [st] = Saw(t(i),A,n,f);  
    signalSaw(i) = st;  
end
plot(t*ms,signalOBD,'-m');hold on
plot(t*ms,signalSaw,'--r')

% perform Fouriere series with Fkoefs coefficients for OBD
h=figure;
fun=0;
    for i=1:2:FlengthOBD
        subplot(FlengthOBD,1,i)
        fun = fun + A*FkoefsOBD(i)*sin(i*2*pi*f*t);
        plot(t*ms,fun);hold on
        plot(t*ms,signalOBD,'-r')
    end    
    
end

function [st] = OBD(t,A,n,f)
% n - liche cislo
suma=0;
for k=1:2:n
    suma = suma + sin(2*pi*f*k*t)/double(k);
end
st = A*suma;
end

function [st] = Saw(t,A,n,f)
% n - liche cislo
suma=0;
for k=1:n
    suma = suma - sin(2*pi*f*k*t)/double(k);
end
st = A*suma;
end