% signal se sumem - zpetna transformace
%  definuju anonymni funkce
clear all; close all; clc;

% %  !!! DODRZET PODMINKU N/f = cele cislo !!! 
% %  potom ziskam frekvenci tim, ze frekvencni osu vydelim koef = N/f
% %  spektrum je symetricke kolem N/2
% %  to muzu videt kdyz vytisku fazi

Fsig = @(t) sin(2*pi.*t);
Fnoise = @(N,max) (2.*rand(1,N)-1).*max ;
f = 15; % sampl. frekvence
T = 1/f; % sampl. perioda
N = 105; % pocet vzorku
t = 0:T:(N-1)*T; % casovy vektor
max = 0.5;

% moje vzorky
s_t = Fsig(t) + Fnoise(N,max);  
koef = zeros(N,N);
W = exp(-i*2.*pi/double(N));

for i= 1:N
   for j= 1:N      
       koef(i,j) = W^((i-1)*(j-1));
   end    
end

% vyresim soustavu S_prime = koef*s_t'
S_prime = zeros(1,N); % vektor vyslednych hodnot
for i=1:N        
    soucin = 0;
   for j= 1:N           
    soucin = soucin + koef(i,j)*s_t(j);       
   end
   S_prime(i) = soucin;       
end

S_prime2 = abs(S_prime)/double(N);

DftMatlab = fft(s_t);
S_primeMatlab= abs(DftMatlab)/double(N);
S_primeFaze = imag(S_prime);

% vykreslim vysledky
h = figure;
subplot(3,1,1)
plot(t, s_t,'-*b'); hold on
plot(t, Fsig(t),'--g','linewidth',2); hold on
legend('Signal+sum','puvodni signal');
xlabel('vzorky N'); ylabel('s(t)');
title('Signal se sumem');

subplot(3,1,2)
% nasobek = 0:1:(N-1)/2;
% stem(nasobek(:),S_prime(1:length(nasobek)));
nasobek = 0:1:(N-1);
stem(nasobek,S_prime2);
xlabel('ferkvence f'); ylabel('M(s)/N');
%  M je cetnost
xmax = N-1 + 0.05;
xlim([-0.05 xmax]);
title('Spektrum signalu');


subplot(3,1,3)
% nasobek = 0:1:(N-1)/2;
% stem(nasobek(:),S_prime(1:length(nasobek)));
nasobek = 0:1:(N-1);
stem(nasobek,S_primeFaze);
xlabel('ferkvence f'); ylabel('Imag(s(n))');
xmax = N-1 + 0.05;
xlim([-0.05 xmax]);
title('Faze signalu');

h1 = figure;
stem(nasobek(:),S_prime2(1:length(nasobek)),'-r','linewidth',3); hold on
stem(nasobek(:),S_primeMatlab(1:length(nasobek)),'--b');
xlabel('ferkvence f'); ylabel('N(f)');
legend('MojeDFT','Matlab');

%  provedu zpetnou transformaci 
%  provadim zpetnou transformaci signalu komplexnicho - S_prime

zpetna = ifft(S_prime);
zpetnaABS = abs(zpetna);
zpetnaFull = real(zpetna) + imag(zpetna);
h2 = figure;
subplot(2,1,1)
plot(t,s_t,'-*b'); hold on
plot(t,zpetnaABS,'--g','linewidth',2);
legend('signal+sum','zpetna DFT - realna cast');
xlabel('vzorky N'); ylabel('s(t), DFTsignal');
title('Puvodni signal a realna cast zpetne transformace');

subplot(2,1,2)
plot(t,s_t,'-*b'); hold on
plot(t,zpetnaFull,'--g','linewidth',2);
legend('signal+sum','zpetna DFT - realna i imag. cast');
xlabel('vzorky N'); ylabel('s(t), DFTsignal');
title('Puvodni signal a realna+imag. cast zpetne transformace');

