clear all; close all; clc;

% nastaveni komplexniho cisla - implicitne i, ale to se muze prepsat
icom = complex(0,1);

Fsig = @(t) sin(2*pi.*t);
Fnoise = @(N,max) (2.*rand(1,N)-1).*max ;
f = 15; % sampl. frekvence
T = 1/f; % sampl. perioda
N = 105; % pocet vzorku
t = 0:T:(N-1)*T; % casovy vektor
max = 1.8;

% moje vzorky
s_t = Fsig(t) + Fnoise(N,max);  
koef = zeros(N,N);
W = exp(-icom*2.*pi/double(N)); % komplexni

for i= 1:N
   for j= 1:N      
       koef(i,j) = W^((i-1)*(j-1));
   end    
end

% vyresim soustavu S_prime = koef*s_t'
S_prime = zeros(1,N); % vektor vyslednych hodnot
for i=1:N        
    soucin = 0;
   for j= 1:N           
    soucin = soucin + koef(i,j)*s_t(j);       
   end
   S_prime(i) = soucin;       
end

S_prime2 = abs(S_prime)/double(N);

DftMatlab = fft(s_t);
S_primeMatlab= abs(DftMatlab)/double(N);
S_primeFaze = imag(S_prime);

% vykreslim vysledky
h = figure;
subplot(3,1,1)
plot(t, s_t,'-*b'); hold on
plot(t, Fsig(t),'--g','linewidth',2); hold on
legend('Signal+sum','puvodni signal');
xlabel('vzorky N'); ylabel('s(t)');
title('Signal se sumem');

subplot(3,1,2)
% nasobek = 0:1:(N-1)/2;
% stem(nasobek(:),S_prime(1:length(nasobek)));
nasobek = 0:1:(N-1);
stem(nasobek,S_prime2);
xlabel('ferkvence f'); ylabel('M(s)/N');
%  M je cetnost
xmax = N-1 + 0.05;
xlim([-0.05 xmax]);
title('Spektrum signalu');


subplot(3,1,3)
% nasobek = 0:1:(N-1)/2;
% stem(nasobek(:),S_prime(1:length(nasobek)));
nasobek = 0:1:(N-1);
stem(nasobek,S_primeFaze);
xlabel('ferkvence f'); ylabel('Imag(s(n))');
xmax = N-1 + 0.05;
xlim([-0.05 xmax]);
title('Faze signalu');

% -------------------------------------------------------------------------
%  odstraneni sumu dle threshold
%  vsechny frekvence < threshold = 0;
%  threshold aplikuji na pole relativnich cetnost  - (0,1)
%  threshold = (0,1);

threshold = 0.5;
for iter = 1:length(S_prime)
   val = S_prime2(iter) ; % tady mam velikosti obecne komplexnich cisel   
   if(val < threshold)
       S_prime(iter) = 0 + 0i; % ulozim obecne komplexni cislo - kvuli zpetne transformaci     
   end    
end

%  aplikuji zpetnou transformaci na signal bez sumu
zpetna = ifft(S_prime);
zpetnaFull = real(zpetna) + imag(zpetna);
% -------------------------------------------------------------------------

h2 = figure;
subplot(2,1,1)
plot(t,s_t,'-*b'); hold on
plot(t,zpetnaFull,'--g','linewidth',2);
legend('signal+sum','zpetna DFT - bez sumu');
xlabel('vzorky N'); ylabel('s(t), DFTsignal');
title('Puvodni signal a realna+imag. cast zpetne transformace');

subplot(2,1,2)
plot(t,Fsig(t),'--b'); hold on
plot(t,zpetnaFull,'--g','linewidth',2);
legend('signal bez sumu','zpetna DFT - bez sumu');
xlabel('vzorky N'); ylabel('s(t), DFTsignal');
title('Puvodni signal bez sumu a signal po filtraci DFT');


