clear all; close all; clc;
%parametry signalu
A0 = 5;
T = 10; % s
f = 1/T; % Hz

% parametry sumu
koef = 2;
minv = -1.*koef*A0;
maxv = koef*A0;
% vzorkovani
N = 11; % pocet vzorku v jednom opakovani
M = 50; % pocet opakovani
Mn = M*N; % celkovy pocet vzorku
%--------------------------------------------------------------------------
F_det = @(A0,f,t) A0*sin(2*pi*f.*t);
F_rand = @(minv,maxv,Mn) (maxv-minv)*rand(1,Mn) + minv;

tmin = 0;
tmax = M*T; % maximalni cas
dt = T/double(N);

t = tmin:dt:tmax-dt;
%--------------------------------------------------------------------------
% signal se sumem
signaldet = F_det(A0,T,t);
chaos = F_rand(minv,maxv,Mn);
signal = signaldet+chaos;

h = figure;
h = plot(t,signaldet,'-*b'); hold on
h = plot(t,chaos,'-r'); hold on
h = plot(t,signal,'-g','linewidth',2);
h = legend('deterministicka cast','nahodna cast','signal se sumem');

% korelacni analyza pomoci prime korelace v casove oblasti
% parametr tau urcuje pocet vzorku, o ktere jsem posunuty
% lze ho volit v rozmezi tau = 1:N-tau, ale tam uz mam spatnou statistiku
% mam pravidlo abs(tau) >> N, kde N-pocet vzorku

Ntau = floor(Mn/2);
CorFun = zeros(1,Ntau);
for tau = 0:Ntau-1
    
    CorTmp = 0;
    for i = 1:Mn-tau % cyklus od prvniho do N-tau-teho vzorku
        %     CorTmp = CorTmp + signaldet(i)*signaldet(i+tau);
              CorTmp = CorTmp + signal(i)*signal(i+tau);
        %        CorTmp = CorTmp + chaos(i)*chaos(i+tau);
    end
    CorFun(tau+1) = CorTmp/double(Mn-tau);
end

h1 = figure;
t_tau = 1:Ntau;
h1 = plot(t_tau,CorFun,'--r');hold on
h1 = plot(t,signaldet,'-*b');





