%  nageneruji signal s periodou T
%  delka signalu bude M period
%  v kazde periode bude N vzorku
%  pomoci funkce rand zavedu do signalu sum  
%  signal nageneruji segmentovane a vykreslim pomoci subplot
%  provedu kumulaci signalu 
%  a) klasickou metodou dle poctu vzorku
%  b) exponencialni metodou
%  porovnam vysledky

clear all; close all; clc;
format short

%parametry signalu
A0 = 5;
T = 10; % s
f = 1/T; % Hz

% parametry sumu
minv = -1.*A0;
maxv = A0;
% vzorkovani
N = 51; % pocet vzorku v jednom opakovani
M = 100; % pocet opakovani
Mn = M*N; % celkovy pocet vzorku
%--------------------------------------------------------------------------
F_det = @(A0,f,t) A0*sin(2*pi*f.*t);
F_rand = @(minv,maxv,Mn) (maxv-minv)*rand(1,Mn) + minv;

tmin = 0;
tmax = M*T; % maximalni cas 
dt = T/double(N);
t = tmin:dt:tmax-dt;
%--------------------------------------------------------------------------
% signal se sumem
signaldet = F_det(A0,T,t);
chaos = F_rand(minv,maxv,Mn);
signal = signaldet+chaos;
%--------------------------------------------------------------------------
h = figure;
h = plot(t,signaldet,'-*b'); hold on
h = plot(t,chaos,'-r'); hold on
h = plot(t,signal,'-g','linewidth',2); 
h = legend('deterministicka cast','nahodna cast','signal se sumem');

%  prevedu na jednotlive useky a vykreslim
tint = reshape(t,N,M); % cas v blocich
sint = reshape(signal,N,M); % signal v blocich
orig = reshape(signaldet,N,M); % puvodni signal v blocich
h1 = figure;
for i= 1:M
   subplot(M,1,i)
   plot(tint(:,i),sint(:,i),'-b'); hold on
   plot(tint(:,i),orig(:,i),'-r'); hold on
end
% -------------------------------------------------------------------------
%  klasicke prumerovani - vsechny vahy jsou nastaveny na 1/M
sigK = zeros(N,1);

for i= 1:N   
    sigK(i) = sum(sint(i,:))/double(M);                
end

h3 = figure;
plot(t,signal,'-b'); hold on
plot(t,signaldet,'-g'); hold on
plot(tint(:,1),sigK(:),'-r','linewidth',2)
xlim([0 T])

%--------------------------------------------------------------------------
