% program pro mplitudovou modulaci signalu

clear all; close all; clc;

fn = 5; % Hz - nosna frekvence
fm = 0.5; % modulacni frekvence
Nn = 5; % amplit.nosne
Nm = 2; % amplit. modulacni

tmax = 4*pi;
tmin = 0;
N = 1e3; % deleno casove osy
dt = (tmax-tmin)/double(N);
t = tmin:dt:tmax;

nosna = @(Nn, fn,t) Nn*sin(2*pi*fn.*t);
modul = @(Nm, fm,t) Nm*sin(2*pi*fm.*t);
Cast1 = @(Nm, fn,fm,t) (Nm/2.)*(cos(2*pi*(fm-fn).*t));
Cast2 = @(Nm, fn,fm,t) (Nm/2.)*(cos(2*pi*(fm+fn).*t));

vysl = nosna(Nn, fn,t) + modul(Nm, fm,t).*nosna(Nn, fn,t);
vysl1 = nosna(Nn, fn,t) + Cast1(Nm, fn,fm,t) - Cast2(Nm, fn,fm,t) ;
Rozdil1 = nosna(Nn, fn,t) + Cast1(Nm, fn,fm,t);
Soucet1 = nosna(Nn, fn,t) + Cast2(Nm, fn,fm,t);

h = figure;
h = plot(t,nosna(Nn, fn,t),'-b'); hold on
h = plot(t,modul(Nm, fm,t),'-r','linewidth',2); hold on
h = plot(t,vysl,'-g','linewidth',2); hold on
legend('Nosna vlna','Modulacni signal','Modulovany signal')
xlabel('cas t');
ylabel('Amplituda');


h1 = figure;
h1 = plot(t,modul(Nm, fm,t),'-c','linewidth',2); hold on
h1 = plot(t,vysl1,'-r','linewidth',1); hold on
h1 = plot(t,Rozdil1,'-g','linewidth',1); hold on
h1 = plot(t,Soucet1,'-b','linewidth',1); hold on
legend('Modulacni vlna','Plna Modulace','Rozdilove pasmo','Souctove pasmo')
xlabel('cas t');
ylabel('Amplituda');


