%  program pro frekvencni modulaci signalu
clear all; close all; clc;
 A0 = 5; %amplituda
 Omega = 15; % Hz - nosny signal
 deltaO = 25; % frekvencni zdvih
 mFM = 1.5;
 omega = deltaO/mFM; % uhlov. frekvence modulacni signal
 
 
 nosna = @(A0,Omega,t) A0*sin(Omega.*t);
 modulacni = @(deltaO,omega,t) deltaO*sin(omega.*t);
 vysl = @(deltaO,omega,mFM,t) A0*sin(Omega.*t).*cos(mFM.*sin(omega.*t))...
                                + A0*cos(Omega.*t).*sin(mFM.*sin(omega.*t));
                            
tmin = 0;
tmax = 2*pi;
N = 1e3; % pocet vzorku
dt = (tmax-tmin)/double(N);
t = tmin:dt:tmax;


plot(t,nosna(A0,Omega,t),'-b'); hold on
plot(t,modulacni(deltaO,omega,t),'-r'); hold on
plot(t, vysl(deltaO,omega,mFM,t),'-g', 'Linewidth',3); hold on
legend('Nosna vlna','Modulacni vlna','Modulovany signal')
xlabel('cas t');
ylabel('Amplituda');

% TODO frekvence v signalu - zatim bz Fourierovy analyzy
%  pouzitim Besselovych funkci!
